#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

    in(int, n);
    vector<vector<int>> r(n + 1);
    vector<vector<int>> pos(n);
    for (int i = 0; i < n; i++) {
        in(int, x1, x2)
        x1--, x2--;
        r[i] = {x1, x2};
        pos[x1].push_back(i);
        pos[x2].push_back(i);
    }
    int free = n;

    auto depth = [&](int i, int no) {
        return r[i][0] == no ? 0 : 1;
    };
    unordered_set<int> q, wait;
    for (int i = 0; i < n; i++) {
        if (pos[i][0] == pos[i][1]) continue;
        if (depth(pos[i][0], i) > depth(pos[i][1], i)) swap(pos[i][0], pos[i][1]);
        wait.insert(i);
        if (depth(pos[i][0], i) == 1 && depth(pos[i][1], i) == 1) {
            q.insert(i);
        }
    }
    vector<pii> ans;

    while (!q.empty()) {
        int t = *q.begin();
        q.erase(t);
        wait.erase(t);
        deque<int> rs{pos[t][0], pos[t][1]};

        int rno = pos[t][1];
        int next = r[rno][0];
        while (true) {
            rno = pos[next][0] ^ pos[next][1] ^ rno;
            rs.push_back(rno);
            wait.erase(next);
            if (depth(rno, next) == 0) break;
            next = r[rno][0];
        }

        ans.emplace_back(rs[0], free);
        ans.emplace_back(rs[1], free);
        for (int i = 2; i < rs.size() - 1; i++) {
            ans.emplace_back(rs[i], rs[i - 1]);
        }
        if (rs.front() == rs.back()) {
            rs.pop_back();
            ans.emplace_back(rs.back(), rs.front());
            wait.erase(r[rs[0]][0]);
        } else {
            ans.emplace_back(rs.back(), rs.front());
            int item = r[rs.back()][1];
            if (pos[item][0] != rs.back()) swap(pos[item][0], pos[item][1]);
            r[rs.front()][1] = r[rs.back()][1];
            pos[item][0] = rs.front();
            ans.emplace_back(rs.back(), rs[rs.size() - 2]);
        }
        free = rs.back();
        r[free].clear();
    }

    for (int i : wait) {
        if (depth(pos[i][0], i) > depth(pos[i][1], i)) swap(pos[i][0], pos[i][1]);
    }
    while (!wait.empty()) {
        int t = *wait.begin();
        ans.emplace_back(pos[t][0], free);
        int top_item = r[pos[t][0]][1];
        pos[top_item][1] = free;
        r[free].push_back(top_item);
        do {
            wait.erase(t);
            ans.emplace_back(pos[t][1], pos[t][0]);
            t = r[pos[t][1]][0];
        } while (wait.count(t));
        r[free].clear();
    }

    cout << ans.size() << '\n';
    for (auto const &e : ans) {
        cout << e.first + 1 << ' ' << e.second + 1 << '\n';
    }

}