#include <bits/stdc++.h>
#include "testlib.h"

#define x first
#define y second
#define all(a) a.begin(), a.end()

typedef long long ll;

using namespace std;

void paint(vector<string> &s, int i, int j){
    s[i - 1][j - 1] = s[i - 1][j + 1] = s[i + 1][j - 1] = s[i + 1][j + 1] = s[i][j] = '*';
}

bool correct(int n, int m, int i, int j){
    return 0 < i && i + 1 < n && 0 < j && j + 1 < m;
}

void gen_case(){
    int n = opt<int>("n");
    int m = opt<int>("m");
    vector<string> s(n, string(m, '.'));
    int len = rnd.next(10, n * m);
    println(n, m);
    int i = rnd.next(1, n - 2), j = rnd.next(1, m - 2);
    vector<pair<int, int>> dir{{-2, 0}, {0, -2}, {0, 2}, {2, 0}};
    for(int _ = 0; _ < len; ++_){
        paint(s, i, j);
        while(true){
            auto d = dir[rnd.next(4)];
            if(correct(n, m, i + d.x, j + d.y)){
                i += d.x;
                j += d.y;
                break;
            }
        }
    }
    for(auto e: s) println(e);
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    gen_case();
    return 0;
}
