#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), m = opt<int>("m"), alpha = opt<double>("alpha"), ok = opt<bool>("ok");

    vector<vector<char>> go('z' + 1);
    for (char c = 'a'; c <= 'z'; c++) {
        for (char c2 = 'a'; c2 <= 'z'; c2++) {
            if (rnd.next() < alpha) {
                go[c].push_back(c2);
            }
        }
        if (go[c].empty()) {
            go[c].push_back(rnd.next('a', 'z'));
        }
    }

    set<pair<char, char>> opts;
    string k;
    char c = rnd.next('a', 'z');
    for (int i = 0; i < n; i++) {
        char c2 = go[c][rnd.next(go[c].size())];
        opts.insert({c, c2});
        k.push_back(c2);
        c = c2;
    }

    for (auto &v : go) {
        v.clear();
    }
    for (auto const &p : opts) {
        go[p.first].push_back(p.second);
    }
    vector<bool> cont('z' + 1, true);
    for (int i = 0; i < 'z' - 'a' + 1; i++) {
        for (char v = 'a'; v <= 'z'; v++) {
            bool has_cont = false;
            for (char v2 : go[v]) {
                has_cont |= cont[v2];
            }
            cont[v] = has_cont;
        }
    }
    vector<char> gos;
    for (char v = 'a'; v <= 'z'; v++) {
        if (cont[v]) {
            gos.push_back(v);
        }
    }

    string s;
    c = gos[rnd.next(gos.size())];
    int fail = m + 1;
    if (!ok) {
        fail = rnd.next(m / 2, m * 3 / 4);
    }
    for (int i = 0; i < m; i++) {
        int idx = rnd.next(go[c].size());
        int iter = 0;
        while (cont[go[c][idx]] != (i != fail) && iter++ < go[c].size()) {
            idx = (idx + 1) % go[c].size();
        }
        char c2 = go[c][idx], c3 = c2;
        if (i == fail && cont[c2]) {
            fail++;
            if (fail > m * 3 / 4) {
                for (c3 = 'a'; c3 <= 'z'; c3++) {
                    if (find(go[c].begin(), go[c].end(), c3) == go[c].end()) {
                        break;
                    }
                }
            }
        }
        s.push_back(c3);
        c = c2;
    }

    println(n);
    println(k);
    println(s);

}