#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef pair<int, int> pii;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair <T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector <T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

    in(int, m)
    int n = m / 2;
    vector<pii> ex(m);
    cin >> ex;

    sort(all(ex));
    ordered_set<pii> width;
    width.insert({1e9 + 1, -1});
    int idx = 0;
    int last_a = -1, last_b = -1;
    for (; idx < n - 1; idx++) {
        width.insert({ex[idx].second, idx});
        if (ex[idx].first > last_a) {
            last_a = ex[idx].first;
            last_b = ex[idx].second;
        }
    }

    int ans = 0;
    while (idx < m) {
        do {
            if (ex[idx].first > last_a) {
                last_a = ex[idx].first;
                last_b = ex[idx].second;
            }
            width.insert({ex[idx].second, idx++});
        } while (idx < m && ex[idx].first == ex[idx - 1].first);

        auto last = width.find_by_order(n - 1)->first;
        auto next = width.find_by_order(n)->first;
        if (next > last && last >= last_b) {
            ans++;
        }
    }

    cout << ans << '\n';

}