#include "bits/stdc++.h"

using namespace std;

using ll = long long;

ll eval(ll a, ll x, char c) {
    if (c == '=') {
        return x;
    } else if (c == '&') {
        return x & a;
    } else if (c == '|') {
        return x | a;
    } else {
        return x ^ a;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> arr(n);
    for (auto &x : arr) {
        cin >> x;
    }
    while (m--) {
        int t, l, r;
        cin >> t >> l >> r;
        if (t == 1) {
            ll answer = 0;
            for (ll i = l; i <= r; i++) {
                answer += (arr[i - 1] ^ i);
            }
            cout << answer << "\n";
        } else {
            ll x;
            cin >> x;
            char c = '=';
            if (t == 3) {
                cin >> c;
            }
            for (int i = l; i <= r; i++) {
                arr[i - 1] = eval(arr[i - 1], x, c);
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}